PROGRAM AUTOMATA(INPUT,OUTPUT);
CONST PC=10;
    AR=11;
    XR=12;
    YR=13;
    GFX=-224;
    GCS=-221;
    GCL=-215;
    CIR=-203;
    RCT=-209;
    LIN=-212;
    SPX=-245;
    GPX=-251;
    PXY=-257;
    STI=-37;
    RTI=-34;
    BLACK=0;
    RED=2;
    GREEN=5;
    BLUE=6;
VAR I,A,B,C,D,SEED,Q,POS: INTEGER;
ROW,NROW: ARRAY [0..199] OF INTEGER;
CODE:ARRAY [0..9] OF INTEGER;
COLORS:ARRAY [0..3] OF INTEGER;
DECODE:ARRAY [0..6] OF INTEGER;
CMD:CHAR;
M,N:BOOLEAN;


PROCEDURE SETTIME(H,M,S:INTEGER);
    BEGIN
        REGS[AR]:=H;
        REGS[XR]:=M;
        REGS[YR]:=S;
        CALL(STI);
    END;

PROCEDURE GRAPHICS;
    BEGIN
        REGS[0]:=0;
        CALL(GFX);
    END;

PROCEDURE GCLEAR;
    BEGIN
        CALL(GCS);
    END;

PROCEDURE PIXELXY(X,Y: INTEGER);
    BEGIN
        REGS[0]:=X;
        REGS[1]:=Y;
        CALL(PXY);
    END;

PROCEDURE SETPIXEL(C: INTEGER);
    BEGIN
        REGS[AR]:=C;
        CALL(SPX);
    END;

FUNCTION GETPIXEL:INTEGER;
    BEGIN
        CALL(GPX);
        GETPIXEL:=REGS[AR];
    END;

PROCEDURE GCOLORS(FG,BG,FILL: INTEGER);
    BEGIN
        REGS[AR]:=FG;
        REGS[YR]:=BG;
        REGS[XR]:=FILL;
        CALL(GCL);
    END;

PROCEDURE RECT(X,Y,W,H,FILL: INTEGER);
    BEGIN
        REGS[PC]:=FILL;
        REGS[0]:=X;
        REGS[1]:=Y;
        REGS[2]:=W;
        REGS[3]:=H;
        REGS[4]:=0;
        CALL(RCT);
    END;

PROCEDURE GETROW(H,I:INTEGER);
    VAR D,E,N,Q:INTEGER;
    BEGIN
        N:=0;
        D:=H;
        E:=I;
        PIXELXY(H,I);
        WHILE N<200 DO BEGIN
            ROW[N]:=GETPX(0);
            N:=N+1;
        END;
    END;

PROCEDURE PUTROW(X,Y:INTEGER);
    VAR X2,Y2,N,C:INTEGER;
    BEGIN
        N:=0;
        X2:=X;
        Y2:=Y;
        PIXELXY(X,Y);
        WHILE N<200 DO BEGIN
            C:=NROW[N];
            SETPIXEL(C);
            N:=N+1;
        END;
    END;    

PROCEDURE NEXTROW;
VAR AL,AC,AR,N,CDX,CL:INTEGER;
    BEGIN
        AL:=0;
        AC:=DECODE[ROW[0]];
        AR:=DECODE[ROW[1]];
        CL:=COLORS[CODE[AL+AC+AR]];
        NROW[0]:=CL;
        N:=2;
        WHILE N<200 DO BEGIN
            AL:=AC;
            AC:=AR;
            AR:=DECODE[ROW[N]];
            NROW[N-1]:=COLORS[CODE[AL+AC+AR]];
            N:=N+1;
        END;
        AL:=AC;
        AC:=DECODE[ROW[199]];
        AR:=0;
        CL:=COLORS[CODE[AL+AC+AR]];
        NROW[199]:=CL;
    END;

PROCEDURE DOROWS;
    BEGIN
        A:=40;
        B:=60;
        PUTROW(B,A);
        GETROW(B,A);
        REPEAT
            NEXTROW;
            PUTROW(B,A+1);
            GETROW(B,A+1); 
			PIXELXY(262,A);
			SETPIXEL(1);
            A:=A+1;
			
        UNTIL A = 191
    END;

PROCEDURE DOBITS(N1:INTEGER);
VAR N,J,B: INTEGER;
    BEGIN
		NROW[POS]:=0;
		NROW[POS+1]:=0;
		NROW[POS+2]:=0;
		NROW[POS+3]:=0;
		NROW[POS+4]:=0;
		NROW[POS+5]:=0;
		NROW[POS+6]:=0;
		NROW[POS+7]:=0;
		N:=N1;
		J:=128;
		B:=POS;
		WHILE J >= 1 DO BEGIN
			IF N >= J THEN BEGIN
				NROW[B]:=COLORS[2];
				N:=N*2;
				N:=N-(J*2);
				N:=N DIV 2;
			END;
			J:=J DIV 2;
			B:=B+1;
		END;
    END;


PROCEDURE PLOT(S:INTEGER);
VAR TMP:INTEGER;
	BEGIN
		SETTIME(0,0,0);
		A:=0;
		C:=0;
		B:=0;
		IF SEED <> 0 THEN BEGIN
			WHILE B < 200 DO BEGIN
				NROW[B]:=COLORS[0];
				B:=B+1;
			END;
		END;
		DOBITS(SEED);
	    DOROWS;
	END;
	
FUNCTION READTIME: INTEGER;
VAR T1:INTEGER;
    BEGIN
        CALL(RTI);
		T1:=(REGS[XR]*256) DIV 60;
        READTIME:= REGS[AR] DIV 60 + T1;     
    END;	

PROCEDURE GETCODE;
    BEGIN
        A:=0;
        GOTOXY(0,2);
        WRITELN('ENTER 10 DIGIT CODE OF 0-3 EACH: ');
        WHILE A < 10 DO BEGIN
            GOTOXY(5+A,27);
            CODE[A]:=9;
            WHILE CODE[A] > 3 DO BEGIN
                READ(CODE[A]);
            END;
            GOTOXY(5+A,27);
            WRITE(CODE[A]);
            A:=A+1;
        END;
        GOTOXY(5+A,27);
        WRITE(' ');
        GOTOXY(0,2);
        WRITELN('                                 ');
    END;
	
PROCEDURE GETSEED;
	BEGIN
        A:=0;
        GOTOXY(0,2);
        WRITELN('ENTER SEED VALUE (1-255): ');
		GOTOXY(23,27);
		READ(SEED);
		IF SEED < 0 THEN SEED:=0;
		IF SEED > 255 THEN SEED:=255;
		GOTOXY(23,27);
		WRITE(SEED,'    ');
        GOTOXY(0,2);
        WRITELN('                         ');
	END;
	
PROCEDURE GETPOS;
	BEGIN
        A:=0;
        GOTOXY(0,2);
        WRITELN('ENTER POSITION VALUE (0-192): ');
		GOTOXY(35,27);
		READ(POS);
		IF POS > 192 THEN POS:=192;
		IF POS < 0 THEN POS:=0;
		GOTOXY(35,27);
		WRITE(POS,'    ');
        GOTOXY(0,2);
        WRITELN('                             ');
	END;	

PROCEDURE INIT;
    BEGIN
        COLORS[0]:=BLACK;
        COLORS[1]:=RED;
        COLORS[2]:=GREEN;
        COLORS[3]:=BLUE;
        DECODE[0]:=0;
        DECODE[1]:=0;
        DECODE[2]:=1;
        DECODE[3]:=1;
        DECODE[4]:=1;
        DECODE[5]:=2;
        DECODE[6]:=3;
        SEED:=237;
		POS:=96;
        CODE[0]:=2;
        CODE[1]:=2; 
        CODE[2]:=2;
        CODE[3]:=1;
        CODE[4]:=1;
        CODE[5]:=3; 
        CODE[6]:=0;
        CODE[7]:=3; 
        CODE[8]:=0;
        CODE[9]:=3; 
        GRAPHICS;
        GCOLORS(0,0,0); 
        CALL(GCS);
        GCOLORS(7,0,0);
        RECT(59,39,202,154,0);      
        GOTOXY(0,0);
        WRITELN('4 STATE LINEAR, CELLULAR AUTOMATA');
        GOTOXY(0,27);
        WRITELN('CODE:');
        Q:=0;
        WHILE Q < 10 DO BEGIN
            GOTOXY(Q+5,27);
            WRITE(CODE[Q]);
            Q:=Q+1;
        END;
        GOTOXY(18,27);
        WRITE('SEED:',SEED);
		GOTOXY(31,27);
		WRITE('POS:',POS);
    END;
	
	
BEGIN
        INIT;
		SETTIME(0,0,0);
		PLOT(SEED);
		GOTOXY(0,2);
		WRITE(READTIME,' SECONDS');
        WHILE CMD <> 'q' DO BEGIN
            GOTOXY(0,1);
            WRITELN('ENTER COMMAND (C,S,P,D,R,M,H,Z,Q): ');
            READ(CMD);
			GOTOXY(34,1);
			WRITE(CMD);
            IF ORD(CMD) = 'd' THEN BEGIN
                GCLEAR;
                RECT(59,39,202,154,0);
                PLOT(SEED);
            END;
            IF ORD(CMD) = 'c' THEN GETCODE;
			IF ORD(CMD) = 's' THEN GETSEED;
			IF ORD(CMD) = 'p' THEN GETPOS;
            IF ORD(CMD) = 'r' THEN BEGIN
                GOTOXY(18,27);
                WRITE('SEED:RANDOM');  
				D:=0;
				WHILE D < 200 DO BEGIN
					SEED:=0;
					NROW[D]:=COLORS[RAND(3)];
					D:=D+1;
				END;
            END;
			IF ORD(CMD) = 'm' THEN BEGIN
				GETROW(60,190);
				GCLEAR;
				RECT(59,39,202,154,0);
				DOROWS;
			END;
			IF ORD(CMD) = 'h' THEN BEGIN
				GOTOXY(0,2);
				WRITELN('C=CHG CODE S=CHG SEED Z=RND CODE D=DRAW');
				WRITE('R=RND SEED M=MORE H=HELP P=CHG POS Q=QUIT');
				READ(CMD);
				GOTOXY(0,2);
				WRITELN('                                           ');
				WRITE('                                             ');
			END;
			IF ORD(CMD) = 'z'THEN BEGIN
				D:=0;
				WHILE D < 10 DO BEGIN
					CODE[D]:=RAND(4);
					D:=D+1;					
				END;
				Q:=0;
				WHILE Q < 10 DO BEGIN
					GOTOXY(Q+5,27);
					WRITE(CODE[Q]);
					Q:=Q+1;
				END;			
			END;
			GOTOXY(34,1);
			WRITE(' ');
        END;
 END.
